// OrgID.cc

#include "OrgID.h"
#include <iostream>
#include <iomanip>
#include <string>
#include <sstream>


ostream& operator << (ostream& os, const OrgID& id)
{
	os << setbase(16);
	os << id.m_Specificity << "o" << id.m_NumGenes << "o" << id.m_Tag;
	os << setbase(10);
	return os;
};

istream& operator >> (istream& is, OrgID& id)
{
	bool error = false;
	unsigned int delim1, delim2;
	string ids;
	
	is >> ids;
	
	delim1 = ids.find("o",0);
	if (delim1 == string::npos)
		error = true;
	
	if (!error)
	{
		delim2 = ids.find("o",delim1+1);
		if (delim2 == string::npos)
			error = true;
	}
	
	if ((!error) && ((delim1 == 0) || (delim2 == ids.length()-1) || (delim2 < delim1+2)))
		error = true;
	
	if (!error)
	{
		string sspec, snumg, stag;
		
		if (ids[0]==':' || ids[0]==';')
		{
			ids = ids.substr( 1, ids.length()-1 );
			sspec = ids.substr( 0, delim1-1 );
			snumg = ids.substr( delim1, delim2-delim1-1 );
			stag  = ids.substr( delim2, ids.length()-delim2 );
		}
		else
		{
			sspec = ids.substr( 0, delim1 );
			snumg = ids.substr( delim1+1, delim2-delim1-1 );
			stag  = ids.substr( delim2+1, ids.length()-delim2 );
		}
		//cout << ids << "," << delim1 << "," << delim2 << ": " << sspec << "," << snumg << "," << stag << ". ";
		
		stringstream ss( sspec + " " + snumg + " " + stag );
		ss << setbase(16);
		ss >> id.m_Specificity >> id.m_NumGenes >> id.m_Tag;
		//cout << spec << "," << numg << "," << tag << "." << endl;
	}
	else
	{
		id.m_Specificity = 0;
		id.m_NumGenes = 0;
		id.m_Tag = 0;
	}
	
	return is;
}

void OrgID::set( string & idStr )
{
	bool error = false;
	unsigned int delim1, delim2;
	
	delim1 = idStr.find("o",0);
	if (delim1 == string::npos)
		error = true;
	
	if (!error)
	{
		delim2 = idStr.find("o",delim1+1);
		if (delim2 == string::npos)
			error = true;
	}
	
	if ((!error) && ((delim1 == 0) || (delim2 == idStr.length()-1) || (delim2 < delim1+2)))
		error = true;
	
	if (!error)
	{
		if (idStr[0]==':' || idStr[0]==';')
			idStr = idStr.substr( 1, idStr.length()-1 );
		
		string sspec = idStr.substr( 0, delim1 );
		string snumg = idStr.substr( delim1+1, delim2-delim1-1 );
		string stag  = idStr.substr( delim2+1, idStr.length()-delim2 );
		
		//cout << " In OrgID set: string=" << idStr << ", spec=" << sspec << ", numg=" << snumg << ", tag=" << stag << " ";
		
		stringstream ss( sspec + " " + snumg + " " + stag );
		ss << setbase(16);
		ss >> m_Specificity >> m_NumGenes >> m_Tag;
	}
	else
	{
		m_Specificity = 0;
		m_NumGenes = 0;
		m_Tag = 0;
	}
}
